/***************************************************/
/* Copyright (c) 2001  Thomas Tydal - dev@tydal.nu */
/***************************************************/

#include <windows.h>
#define REG_MAX 256

BOOL TSFix(char *str);

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd)
{
  HKEY hKey;
  BOOL bFixed = FALSE;
  BOOL bError = TRUE;
  char regBuf[REG_MAX];
  DWORD regBufSize = REG_MAX;
  if (!RegOpenKeyEx(HKEY_CLASSES_ROOT, "Applications", 0, KEY_READ, &hKey))
  {
    if (!RegOpenKeyEx(hKey, "TSUnpack.exe", 0, KEY_READ, &hKey))
    {
      if (!RegOpenKeyEx(hKey, "shell", 0, KEY_READ, &hKey))
      {
        if (!RegOpenKeyEx(hKey, "open", 0, KEY_READ, &hKey))
        {
          if (!RegOpenKeyEx(hKey, "command", 0, KEY_QUERY_VALUE | KEY_SET_VALUE, &hKey))
          {
            RegQueryValueEx(hKey, NULL, NULL, NULL, regBuf, &regBufSize);
            if (regBufSize > 8)
            {
              if (TSFix(regBuf))
              {
                if (!RegSetValueEx(hKey, NULL, 0, REG_SZ, regBuf, strlen(regBuf)))
                  bFixed = TRUE;
              }
            }
          }
        }
      }
    }
  }
  RegCloseKey(hKey);
  if (!RegOpenKeyEx(HKEY_CLASSES_ROOT, "TrainSim.Packaged.Activity", 0, KEY_READ, &hKey))
  {
    if (!RegOpenKeyEx(hKey, "shell", 0, KEY_READ, &hKey))
    {
      if (!RegOpenKeyEx(hKey, "open", 0, KEY_READ, &hKey))
      {
        if (!RegOpenKeyEx(hKey, "command", 0, KEY_QUERY_VALUE | KEY_SET_VALUE, &hKey))
        {
          regBufSize = REG_MAX;
          RegQueryValueEx(hKey, NULL, NULL, NULL, regBuf, &regBufSize);
          if (regBufSize > 8)
          {
            bError = FALSE;
            if (TSFix(regBuf))
            {
              if (!RegSetValueEx(hKey, NULL, 0, REG_SZ, regBuf, strlen(regBuf)))
                bFixed = TRUE;
            }
          }
        }
      }
    }
  }
  if (bFixed && !bError)
    MessageBox(NULL, "TSUnpack Registry Bug was fixed.", "Tsunpack-fix", MB_OK);
  else if (!bError)
    MessageBox(NULL, "TSUnpack Registry Bug already fixed.", "Tsunpack-fix", MB_OK);
  else
    MessageBox(NULL, "There was an error. Check the Registry settings manually.", "Tsunpack-fix", MB_OK);
  return 0;
}

BOOL TSFix(char *str)
{
  int orgLen = strlen(str);
  char temp[80];
  if (str[orgLen - 3] != '%')
  {
    str[orgLen - 2] = '%';
    str[orgLen - 1] = '1';
    str[orgLen]     = '"';
    str[orgLen + 1] = '\0';
    return TRUE;
  }
  return FALSE;
}

